<?php
define('SESSIONTOK','.ssap.txt');

if(!file_exists(SESSIONTOK)){
	print "FALSE:File does not exist".SESSIONTOK;
	exit;
}

if(empty($argv[1])){
	print "FALSE:Insufficient arguments";
	exit;
}

if(!file_exists($argv[1])){
	print "FALSE:shadow file does not exist".$argv[1];
	exit;
}

$linesSSAPFile = file(SESSIONTOK,FILE_IGNORE_NEW_LINES);
if(count($linesSSAPFile) < 1){
	print "FALSE:Invalid file contant ".SESSIONTOK;
	exit;
}

# remove the temp .ssap file
@unlink(SESSIONTOK);
$username = $linesSSAPFile[0];

# read the shadow file contant
$shadowContents = file_get_contents($argv[1]);
preg_match("/^$username:(.*?):/m", $shadowContents, $hashMatch);

if(count($hashMatch) > 0){
	$password = decodePassword($linesSSAPFile[1]);
	$checking_hash = crypt($password, $hashMatch[1]);	
	if ($checking_hash === $hashMatch[1]) 
		print "TRUE";
	else
		print "FALSE:Password Mismatch";
}
else{
	print "FALSE:Unable to find shadow password for user.\n";
	exit;
}

#*******************************************************************************************************
# Subroutine Name         : decodePassword.
# Objective               : This subroutine is for decoding the NAS password
# Added By                : A.K. KamalRaj
#*******************************************************************************************************/
function decodePassword($arg)
{
	$hexPvtKeyArr = preg_split('/-/', $arg);
	array_shift($hexPvtKeyArr);
	array_pop($hexPvtKeyArr);
	for($i = 0; $i < count($hexPvtKeyArr); $i++)
		$hexPvtKeyArr[$i] = chr(hexdec($hexPvtKeyArr[$i]));
	
	$decodeData = join("",$hexPvtKeyArr);
	return $decodeData;
}
?>

