<?php
include_once 'path.php';
if(!isset($_SESSION['validUser']) || $_SESSION['validUser'] !== true)
	exit(header("Location:../index.php"));

$log_filter_dates 	= array('1week' => 'past 1 week', '2week' => 'past 2 week', '1month' => 'past 1 month', 'all' => 'beginning of time');

if(isset($_GET['date_range'])) {
	$sel_date_range		= (($_GET['date_range'] == '' || !array_key_exists($_GET['date_range'], $log_filter_dates))? '1week' : $_GET['date_range']);
} else {
	$sel_date_range		=  '1week';
}
?>
<script>
  IDrive.Scheduler.LoadLogs();
  var logFileList = new Array();
</script>
<div id="log_list" class="container body_wrap logs_wrap">
			  <div class="logos_exclude exclude logs-section">
        <div class="menu">
          <ul class="logs-icon-row" style="width: 200px;">
            <li class="menu_delete_all" title="Delete Selected">
             <a class="menu_deleteall" href="javascript:void(0);" title="Delete Selected" alt="Delete Selected">Delete Selected</a>
             <span>Delete Selected</span>
            </li>
          </ul>
          <ul class="delete_all_disabled" style="width: 200px;">
            <li class="disable_deleteall">
             <a class="disable_deleteall" href="javascript:void(0);" alt="Delete Selected">Delete Selected</a>
             <span>Delete Selected</span>
            </li>
          </ul>			  
			<ul class="log_date_selector">
				<li>
					<span>
						View logs from 
						<select id="log_date_selection">
							<?php foreach($log_filter_dates as $dfilter_key => $dfilter_val) {?>
								<option value="<?php echo $dfilter_key;?>"<?php echo (($sel_date_range == $dfilter_key)? 'selected="selected"' : '');?>><?php echo $dfilter_val;?></option>
							<?php }?>
						</select>
					</span>
				</li>
			</ul>
        </div>
			  <div class="excludeContainer excludeContainer_new">
				 <table cellspacing="0" cellpadding="6" border="0" width="100%" align="center" class="folderBackup disable-hover">
				  <tbody>
					<tr class="excludeheader header_part">
						<td class="file_check"><input type="checkbox" id="mainchek" class="checkcontrol"><label class="">All</label></td>
						<td width="15%"><span class="blue">Status</span></td>
						<td width="29%"><span class="blue">Operation Type</span></td>
						<td width="27%"><span class="blue">Date and Time</span></td>
						<td width="15%" class="excludDetail"><span class="blue">Details</span></td>
						<td width="18%" align="center" class="job_delete"><span class="blue">Clear</span></td>
					</tr>
				</tbody>
			</table>
				<form id="jobLogsList">
			    <div id="log_list_table" class="excludefiles">
					<div class="ajax_loader" style="display: block;"><p>loader...</p></div>
					<!-- Log list will be displayed here -->
				</div>
			</form>
			  </div> 
			  <!-- Confirmation box for Clear Log - Start -->  
			  <div style="width: 550px;" class="popup_container popContent logs_clear_popup popLeft">
				  <section class="popup_header">
					<h4>Clear log</h4>
					<span class="popup_close_btn hide_popup"></span>
				  </section>
				  <section class="popup_body">
					<p>Are you sure you want to delete <span>log</span>?</p>
				 <div class="clear"></div>
				  </section>
				   <section class="popup_footer">
					<div class="btncontainer">				
						<input type="button" value="Ok" class="addButton" id="clearLogButton">
						<input type="button" value="Cancel" class="addButton popup_cancelBtn">
						<input type="hidden" id="clearLogObject">
					</div>
				 </section>
			  </div>  
			  <!-- Confirmation box for Clear Log - End -->	
			<!-- Confirmation box for Clear Log - Start -->  
			<div style="width: 550px;" class="popup_container popContent logs_clearall_popup popLeft">
				<section class="popup_header">
					<h4>Clear all logs</h4>
					<span class="popup_close_btn hide_popup"></span>
				</section>
				<section class="popup_body">
					<p>Are you sure you want to delete all selected <span>logs</span>?</p>
				    <div class="clear"></div>
				</section>
				<section class="popup_footer">
					<div class="btncontainer">
						<input type="button" value="Ok" class="addButton" id="clearAllLogButton">
						<input type="button" value="Cancel" class="addButton popup_cancelBtn">
					</div>
				</section>
			</div>  
			  <!-- Confirmation box for Clear Log - End -->				  
			   <div class="logs_notes">
				   <!-- <strong>Note:</strong> 
				   <span class="green">Success*</span> indicates majority of files are successfully backed up/restored. -->
			   </div>
			  </div>
</div>
